/* ==================================================================== */
/* Allan CORNET */
/* DIGITEO 2008 */
/* ==================================================================== */
#include "../../src/c/dde.h"
#include "stack-c.h" 
#include "MALLOC.h"
#include "BOOL.h"
#include "Scierror.h"
#include "localization.h"
/* ==================================================================== */
int sci_ddeopen(char *fname)
{
	Rhs = Max(0, Rhs);
	CheckRhs(2, 2);
	CheckLhs(0, 1);

	if ( (GetType(1) == sci_strings) && (GetType(2) == sci_strings) )
	{
		int l1 = 0, n1 = 0, m1 = 0;
		int l2 = 0, n2 = 0, m2 = 0;

		int *paramoutINT = NULL;
		char *param1 = NULL, *param2 = NULL;
			
		GetRhsVar(1, STRING_DATATYPE,&m1,&n1,&l1);
		param1 = cstk(l1);

		GetRhsVar(2, STRING_DATATYPE,&m2,&n2,&l2);
		param2 = cstk(l2);

		paramoutINT = (int*)MALLOC(sizeof(int));
		if (paramoutINT == NULL)
		{
			Scierror(999, _("%s: No more memory.\n"),fname) ;
			return 0;
		}
			
		if ( DDEOpenConnection(param1, param2) )
		{
			*paramoutINT = (int)(TRUE);
		}
		else
		{
			*paramoutINT = (int)(FALSE);
		}

		n1 = 1;
		CreateVarFromPtr(Rhs+1, MATRIX_OF_BOOLEAN_DATATYPE, &n1, &n1, &paramoutINT);
		LhsVar(1) = Rhs+1;
		FREE(paramoutINT);
		paramoutINT = NULL;
	}
	else 
	{
		Scierror(999,_("%s: Wrong type for input argument: String expected.\n"),fname);
	}
	return 0;
}
/* ==================================================================== */
