/* ==================================================================== */
/* Allan CORNET */
/* DIGITEO 2008 */
/* ==================================================================== */
#include "../../src/c/dde.h"
#include "stack-c.h" 
#include "MALLOC.h"
#include "Scierror.h"
#include "localization.h"
/* ==================================================================== */
int sci_ddepoke(char *fname)
{
	int l1 = 0, n1 = 0, m1 = 0;
	int *param3 = NULL;

	Rhs = Max(0,Rhs);
	CheckRhs(2,3);
	CheckLhs(0,1);

	if (Rhs == 3)
	{
		if (GetType(3) == sci_matrix)
		{
			GetRhsVar(3, MATRIX_OF_INTEGER_DATATYPE, &m1, &n1, &l1);
			if ( (m1 == 1) && (n1 == 1) )
			{
				param3 = istk(l1);
			}
			else
			{
				Scierror(999,_("%s: Wrong size for input argument #%d: A scalar expected.\n"),fname,3);
				return 0;
			}
		}
		else
		{
			Scierror(999,_("%s: Wrong type for input argument #%d: A scalar expected.\n"),fname,3);
			return 0;
		}
	}

	if (Rhs == 2)
	{
		param3 = (int*)MALLOC(sizeof(int));
		if (param3 == NULL)
		{
			Scierror(999, _("%s: No more memory.\n"),fname) ;
			return 0;
		}
		*param3 = -1;
	}

	if ( (GetType(1) == sci_strings) && (GetType(2) == sci_strings))
	{
		char *param1 = NULL, *param2 = NULL;
		int *paramoutINT = NULL;
		
		GetRhsVar(1,STRING_DATATYPE,&m1,&n1,&l1);
		param1 = cstk(l1);

		GetRhsVar(2,STRING_DATATYPE,&m1,&n1,&l1);
		param2 = cstk(l1);
		
		paramoutINT = (int*)MALLOC(sizeof(int));
		if (paramoutINT == NULL)
		{
			if (Rhs == 2)
			{
				if (param3) FREE(param3);
				param3 = NULL;
			}
			Scierror(999, _("%s: No more memory.\n"),fname) ;
			return 0;
		}

		if ( DDEPoke(param1,param2,*param3) )
		{
			*paramoutINT = (int)TRUE;
		}
		else
		{
			*paramoutINT = (int)FALSE;
		}
		
		n1=1;
		CreateVarFromPtr(Rhs+1, MATRIX_OF_BOOLEAN_DATATYPE, &n1, &n1, &paramoutINT);
		LhsVar(1) = Rhs+1;
		FREE(paramoutINT);
		paramoutINT = NULL;
	}
	else
	{
		Scierror(999,_("%s: Wrong type for input argument: String expected.\n"),fname);
	}

	if (Rhs == 2)
	{
		if (param3) FREE(param3);
		param3 = NULL;
	}
	
	return 0;
}
/* ==================================================================== */

