/* ==================================================================== */
/* Allan CORNET */
/* DIGITEO 2008 */
/* ==================================================================== */
#include <stdio.h>
#include "../../src/c/dde.h"
#include "stack-c.h" 
#include "MALLOC.h"
#include "Scierror.h"
#include "localization.h"
/* ==================================================================== */
int sci_ddereq(char *fname)
{
	int l1 = 0, n1 = 0, m1 = 0;
	int *param2 = NULL;

	Rhs = Max(0,Rhs);
	CheckRhs(1,2);
	CheckLhs(0,1);

	if (Rhs == 2)
	{
		if (GetType(2) == sci_matrix)
		{
			GetRhsVar(2,MATRIX_OF_INTEGER_DATATYPE,&m1,&n1,&l1);
			if ( (m1 == 1) && (n1 == 1) )
			{
				param2 = istk(l1);
			}
			else
			{
				Scierror(999,_("%s: Wrong size for input argument #%d: A scalar expected.\n"),fname,2);
				return 0;
			}
		}
		else
		{
			Scierror(999,_("%s: Wrong type for input argument #%d: A scalar expected.\n"),fname,2);
			return 0;
		}
	}

	if (Rhs == 1)
	{
		param2 = (int*)MALLOC(sizeof(int));

		if (param2 == NULL)
		{
			Scierror(999, _("%s: No more memory.\n"),fname) ;
			return 0;
		}

		*param2 = -1;
	}

	if (GetType(1) == sci_strings)
	{
		#define defaultMaxBuffer 2
		int lenBuffer = defaultMaxBuffer;
		char *Buffer = (char*)MALLOC(sizeof(char) * defaultMaxBuffer);
		char *param1 = NULL;
			
		GetRhsVar(1, STRING_DATATYPE, &m1, &n1, &l1);
		param1 = cstk(l1);

		if ( DDERequest(param1, *param2, &Buffer, &lenBuffer) )
		{
			int lenBuffer = (int) strlen(Buffer);
			if ( (Buffer) && (lenBuffer > 2) )
			{
				// remove '\r\n'
				if (Buffer[lenBuffer-1] == '\n')
				{
					Buffer[lenBuffer-1] = '\0';
				}
				if (Buffer[lenBuffer-2] == '\r')
				{
					Buffer[lenBuffer-2] = '\0';
				}
			}

			m1 = (int)strlen(Buffer);
			n1 = 1;
			CreateVarFromPtr( Rhs+1, STRING_DATATYPE, &m1, &n1, &Buffer);
			LhsVar(1) = Rhs+1;
		}
		else
		{
			m1=0;
			n1=0;
			l1=0;
			CreateVar(Rhs+1,MATRIX_OF_DOUBLE_DATATYPE,  &m1, &n1, &l1);
			LhsVar(1) = Rhs+1;
		}

		if (Buffer) {FREE(Buffer); Buffer = NULL;}
	}
	else
	{
		Scierror(999,_("%s: Wrong type for input argument #%d: A string expected.\n"),fname,1);
	}

	if (Rhs == 1)
	{
		if (param2) FREE(param2);
		param2 = NULL;
	}
	return 0;
}
/* ==================================================================== */

